<?php

	/*
	Plugin Name: wpShopGermany - Protected Shops
	Plugin URI: http://wpshopgermany.maennchen1.de/
	Description: Protected shops integration
	Author: maennchen1.de
	Version: 1.0
	Author URI: http://maennchen1.de/
	*/
	
	error_reporting(E_ERROR);

	class wpsg_protected_shops
	{
		
		var	$SC = false;
		
		public function __construct($SC = false)
		{
			
			$this->SC = $SC;
			
		} // public function __construct($SC = false)
		
		function dispatch()
		{
			
			if (isset($_REQUEST['form_submit']))
			{
				
				$this->saveForm();
				
			}
			
			?>
<style type="text/css">
	
	table tr td { text-align:left; }
	table tr th { text-align:left; }
	
	.wpsg_ps_page { width:200px; float:left; min-height:1px; margin-right:10px; }
	.wpsg_ps_page select { width:200px; }
	label.pwsg_ps_update { width:auto; line-height:25px; vertical-align:middle; }
	.wpsg_ps_status { width:150px; float:left; min-height:1px; }
	
</style>			
			
<form method="POST">
	<table style="width:800px; margin:15px;">
		<div class="wrap">
		<div class="icon32" id="icon-themes"><br></div>
		<h2>WpShopGermany - Protected Shops Integration <a href="http://wpshopgermany.maennchen1.de/2010/06/20/protected-shops/">?</a></h2>
		<?php echo $this->showForm(); ?>
	</table>
</form>
			<?php
			
		} // function dispatch()
		
		function saveForm()
		{
						
      update_option("wpshopgermany_agbpage", $_REQUEST['wpsg_ps_page']['wpshopgermany_agbpage']);		
      update_option("wpshopgermany_wrpage", $_REQUEST['wpsg_ps_page']['wpshopgermany_wrpage']);		           
      update_option("wpshopgermany_dspage", $_REQUEST['wpsg_ps_page']['wpshopgermany_dspage']);
      update_option("wpshopgermany_vkpage", $_REQUEST['wpsg_ps_page']['wpshopgermany_vkpage']);
			update_option("wpshopgermany_imppage", $_REQUEST['wpsg_ps_page']['wpshopgermany_imppage']);
			
			update_option("wpshopgermany_ts_shopid", $_REQUEST['wpshopgermany_ts_shopid']);
			update_option("wpshopgermany_ts_platform", $_REQUEST['wpshopgermany_ts_platform']);
			update_option("wpshopgermany_ts_username", $_REQUEST['wpshopgermany_ts_username']);
			update_option("wpshopgermany_ts_userpass", $_REQUEST['wpshopgermany_ts_userpass']);
			
			if (is_array($_REQUEST['wpshopgermany_ts_refresh']))
			{
 				
				//$this->controller->modText .= 'Dokumente abgeglichen.';
				
				$url = "https://www.protectedshops.de/api/";
				$user = get_option('wpshopgermany_ts_username');
				$password = get_option('wpshopgermany_ts_userpass');
								
				foreach ($_REQUEST['wpshopgermany_ts_refresh'] as $dok => $ok)
				{
															
					$post['Request'] = "GetDocument";
					$post['Platform'] = get_option('wpshopgermany_ts_platform')	;
					$post['ShopId'] = get_option('wpshopgermany_ts_shopid');
					$post['Document'] = $dok;
					
					if ($dok == "WiderrufEmail")
					{
						$post['Format'] = "Text"; 
					}
					else					
						$post['Format'] = "Html";
						
					$post['Version'] = 1.2;
					
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, $url);
					curl_setopt($ch, CURLOPT_USERAGENT,$_SERVER['HTTP_USER_AGENT']);
					curl_setopt($ch, CURLOPT_POST, 1);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
					curl_setopt($ch, CURLOPT_USERPWD, $user.":".$password);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					
					if (($result=curl_exec($ch)) === FALSE)
					{
						echo 'Curl-Fehler: ' . curl_error($ch);
					}
					else
					{
																		
						if (preg_match("/\<Error\>(.*)\<\/Error\>/s", $result))
						{
							
							update_option("wpshopgermany_ts_version_".$dok, preg_replace("/((.*)\<errormessage\>)|(\<\/errormessage\>(.*))/mi", "", $result));
													
						}
						else
						{
							
							$content = preg_replace("/((.*)\<document\>\<\!\[CDATA\[)|(\]\]\>\<\/document\>(.*))/si", "", $result);
							
							$date = preg_replace("/((.*)\<documentdate\>)|(\<\/documentdate\>(.*))/si", "", $result);
							update_option("wpshopgermany_ts_version_".$dok, $date);
							update_option("wpshopgermany_ts_time_".$dok, date("d.m.Y H:i:s", time()));
							
							global $wpdb;
							
							switch (trim($dok))
							{
								case "AGB":				
									$this->UpdateQuery($wpdb->prefix."posts", array("post_content" => $content), "`ID` = '".get_option('wpshopgermany_agbpage')."'");
									break;
								case "Datenschutz":
									$this->UpdateQuery($wpdb->prefix."posts", array("post_content" => $content), "`ID` = '".get_option('wpshopgermany_dspage')."'");
									break;
								case "Widerruf":
									$this->UpdateQuery($wpdb->prefix."posts", array("post_content" => $content), "`ID` = '".get_option('wpshopgermany_wrpage')."'");
									break;
								case "Impressum":									
									$this->UpdateQuery($wpdb->prefix."posts", array("post_content" => $content), "`ID` = '".get_option('wpshopgermany_imppage')."'");
									break;
								case "Versandinfo":
									$this->UpdateQuery($wpdb->prefix."posts", array("post_content" => $content), "`ID` = '".get_option('wpshopgermany_vkpage')."'");
									break;
								case "WiderrufEmail":
									
									$mail_content = $this->fetchOne("SELECT `value` FROM `".$this->SC->tbl_tp."` WHERE `id` = '5'");
									$mail_content = preg_replace("/###Widerruf_start###(.*)###Widerruf_ende###/is", "###Widerruf_start###\n".$content."\n###Widerruf_ende###", $mail_content);
									
									$this->UpdateQuery($this->SC->tbl_tp, array(
										"value" => $mail_content
									), "`id` = '5'");
																											
									break;
							}
														 							
						}
						 
					}

				} 
				
			}
			
		} // function saveForm()
		
		function showForm()
		{
			
			$arPages = array(
				array("AGB", "AGB", "wpshopgermany_agbpage"),
				array("Datenschutz", "Datenschutzerklärung", "wpshopgermany_dspage"),				
				array("Widerruf", "Widerruf", "wpshopgermany_wrpage"),
				array("Impressum", "Impressum", "wpshopgermany_imppage"),
				array("Versandinfo", "Versandinfo", "wpshopgermany_vkpage")
			);
			
			if (get_option('wpshopgermany_installed') > 0) $arPages[] = array("WiderrufEmail", "Widerruf (Kundenmail)", -1);
									
			$content = '
					<tr>
						<th><label for="wpshopgermany_ts_shopid">'._("Protected Shop ID:").'</label></th> 
						<td style="width:550px;"><input type="text" class="regular-text" id="wpshopgermany_ts_shopid" name="wpshopgermany_ts_shopid" value="'.get_option('wpshopgermany_ts_shopid').'" size="20"></td>
					</tr>
					<tr>
						<th><label for="wpshopgermany_ts_platform">'._("Platform (Online Shop?):").'</label></th> 
						<td><input type="text" class="regular-text" id="wpshopgermany_ts_platform" name="wpshopgermany_ts_platform" value="'.get_option('wpshopgermany_ts_platform').'" size="20"></td>
					</tr>
					<tr>
						<th><label for="wpshopgermany_ts_username">'._("Protected Shop Benutzername:").'</label></th> 
						<td><input type="text" class="regular-text" id="wpshopgermany_ts_username" name="wpshopgermany_ts_username" value="'.get_option('wpshopgermany_ts_username').'" size="20"></td>
					</tr>
					<tr>
						<th><label for="wpshopgermany_ts_userpass">'._("Protected Shop Passwort:").'</label></th> 
						<td><input type="text" class="regular-text" id="wpshopgermany_ts_userpass" name="wpshopgermany_ts_userpass" value="'.get_option('wpshopgermany_ts_userpass').'" size="20"></td>
					</tr>
					<tr><td colspan="2">&nbsp;</td></tr>
			';
			
			if (get_option("wpshopgermany_ts_shopid") != "" && get_option("wpshopgermany_ts_platform") != "" && get_option("wpshopgermany_ts_username") != "" && get_option("wpshopgermany_ts_userpass") != "")
			{
																
				if (!function_exists('curl_init')) {

					$content .= '
						<tr>
							<th colspan="2"><span style="color:red;">Die Curl Bibliothek muss verfügbar und aktiviert sein.<br/>Informationen darüber finden sie <a href="http://php.net/manual/de/book.curl.php">hier</a>.</span></th>
						</tr>
					';
					
					return $content;
					
				}
				else
				{
							
					$url = "https://www.protectedshops.de/api/";
					$shop_id = get_option('wpshopgermany_ts_shopid');
								 					
					$post['Request'] = "GetDocumentInfo";
					$post['ShopId'] = $shop_id;
									
					$user = get_option('wpshopgermany_ts_username');
					$password = get_option('wpshopgermany_ts_userpass');
				
					$ch = curl_init();
					curl_setopt($ch, CURLOPT_URL, $url);
					curl_setopt($ch, CURLOPT_USERAGENT,$_SERVER['HTTP_USER_AGENT']);
					curl_setopt($ch, CURLOPT_POST, 1);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
					curl_setopt($ch, CURLOPT_USERPWD, $user.":".$password);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					
					$update = Array();
					if (($result = curl_exec($ch)) !== FALSE)
					{
						
						$content_res = preg_replace("/((.*)\<DocumentDate\>)|(\<\/DocumentDate\>(.*))/is", "", $result);
		 
						if (preg_match("/(.*)\<AGB\>(.*)/si", $content_res)) $update['AGB'] = preg_replace("/((.*)\<AGB\>)|(\<\/AGB\>(.*))/is", "", $content_res);
						if (preg_match("/(.*)\<Datenschutz\>(.*)/si", $content_res)) $update['Datenschutz'] = preg_replace("/((.*)\<Datenschutz\>)|(\<\/Datenschutz\>(.*))/is", "", $content_res);
						if (preg_match("/(.*)\<WiderrufEmail\>(.*)/si", $content_res)) $update['WiderrufEmail'] = preg_replace("/((.*)\<WiderrufEmail\>)|(\<\/WiderrufEmail\>(.*))/is", "", $content_res);
						if (preg_match("/(.*)\<Widerruf\>(.*)/si", $content_res)) $update['Widerruf'] = preg_replace("/((.*)\<Widerruf\>)|(\<\/Widerruf\>(.*))/is", "", $content_res);
						if (preg_match("/(.*)\<Impressum\>(.*)/si", $content_res)) $update['Impressum'] = preg_replace("/((.*)\<Impressum\>)|(\<\/Impressum\>(.*))/is", "", $content_res);
						if (preg_match("/(.*)\<Versandinfo\>(.*)/si", $content_res)) $update['Versandinfo'] = preg_replace("/((.*)\<Versandinfo\>)|(\<\/Versandinfo\>(.*))/is", "", $content_res);
									 		
					}	
					
				}
				
				foreach ($arPages as $p)
				{
					
					$content .= '
						<tr>
							<th style="height:25px; vertical-align:middle;"><label><b>'.$p[1].'</b></label></th>
							<td>
					';
					 
					$content .= '<div class="wpsg_ps_page">';
					if ($p[2] != -1)
					{
																		
						$pages = array_merge(
							get_pages(array('post_status' => "publish")),
							get_pages(array('post_status' => "draft"))
						);
																		
						if (sizeof($pages) == 0) { $content .= 'Bitte Seiten anlegen!'; }
						else
						{							
							$content .= '<select name="wpsg_ps_page['.$p[2].']">';
							foreach ($pages as $page) 
							{
								$content .= '<option value="'.$page->ID.'" '.((get_option($p[2]) == $page->ID)?'selected="selected"':'').'>'.$page->post_title.'</option>';
							}
							$content .= '</select>';
																																	
						}
											
					}
					else
					{
						 
					}
					$content .= '</div>';
					
					$content .= '<div class="wpsg_ps_status">';
					if (get_option('wpshopgermany_ts_version_'.$p[0]) != "")
					{
						
						$content .= get_option("wpshopgermany_ts_time_".$p[0]);
						
						if (array_key_exists($p[0], $update) && get_option("wpshopgermany_ts_version_".$p[0]) != $update[$p[0]])
							$content .= '<span style="color:red; font-weight:bold;"><br/>Update vorhanden!</span>';
											
					}
					else
					{
						
						$content .= 'Nicht abgeglichen.';
						
					}
					$content .= '</div>';
									
					if (get_option($p[2]) > 0 || $p[2] == -1)
					{
						
						$content .= '<label class="wpsg_ps_update">Aktualisieren? <input type="checkbox" value="1" name="wpshopgermany_ts_refresh['.$p[0].']"/></label>';	
						
					}			
					
					
					$content .= '
							</td>
						</tr>
					';
					
				}
			}
			 						 			
			if (get_option('wpshopgermany_installed') <= 0)
			{
				$content .= '
					<tr><td colspan="2">&nbsp;</td></tr>
					<tr><td colspan="2"><input type="submit" value="Einstellungen speichern" name="form_submit"></td></tr>
				';
			}
			
			$content .= '
					<tr><td colspan="2">&nbsp;</td></tr>
					<tr>
						<td colspan="2">
							<b>Vorgehensweise:</b>
							<ol>
								<li>Eingabe der Daten aus ihrem Protected Shops Account</li>
								<li>Auswahl der jeweiligen Seiten in ihrem Blog (Seiten müssen bereits existieren)</li>
								<li>Markierung der Dokumente die aktuallisiert werden sollen</li>
							</ol><br/>
							<b>Hinweise:</b>
							<ul>
								<li>Beim Abgleich werden die bestehende Texte der Seite überschrieben.</li>
			';
			
			if (get_option("wpshopgermany_installed") > 0)
			{
				$content .= '<li>Der Widerruf (Kundenmail) wird in das Template "Mailtemplate (Besteller)" zwischen die Marker ###Widerruf_start### und ###Widerruf_ende### eingetragen.</li>';
			}
			
			$content .= '								
								<li>Die Daten für ID, Platform, Username und Passwort erhalten sie in ihrem Protected Shops Account.</li>
							</ul>
						</td>
					</tr>	
			';
			
			return $content;
			
		}
		
		function admin_menu()
		{
			
			add_submenu_page('options-general.php', 'wpShopGermany - Protected Shops', 'Protected Shops', 'administrator', 'wpshopgermany-protectedshops-Admin', array($this, 'dispatch'));
			
		} // function admin_menu()
		
		/* DB Hilfsfunktionen */
		function UpdateQuery($table, $data, $where)
		{
			
			$strQuery = "UPDATE `".$table."` SET ";
			
			foreach ($data as $k => $v)
			{
				
				if ($v != "NOW()" && $v != "NULL" && !is_array($v))
					$v = "'".mysql_real_escape_string($v)."'";
				else if (is_array($v))
					$v = $v[0];
					
				$strQuery .= "`".$k."` = ".$v.", ";
			}
		 
			mysql_query(substr($strQuery, 0, -2)." WHERE ".$where) or wpsg_debug($strQuery."\n\n".mysql_error()."\n\n".print_r(debug_backtrace(), 1));	
			
		} // function UpdateQuery($table, $data, $where)
		
		function fetchOne($strQuery)
		{
			
			$result = mysql_query($strQuery) or wpsg_debug($strQuery."\n\n".mysql_error()."\n\n".print_r(debug_backtrace(), 1));	
			$result = mysql_fetch_row($result);
			
			return $result[0]; 
			
		} // function fetchOne($strQuery)
		
	} // class wpsg_protected_shops

	if (get_option('wpshopgermany_installed') <= 0)
	{
		$wpsg_ps = new wpsg_protected_shops();	
		add_action('admin_menu', array($wpsg_ps, "admin_menu"));
	}

?>